<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPersistableEntity ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPersistableEntity
 * @subpackage Arrays
 */
class ArrayOfPersistableEntity extends AbstractStructArrayBase
{
    /**
     * The PersistableEntity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\PersistableEntity[]
     */
    public $PersistableEntity;
    /**
     * Constructor method for ArrayOfPersistableEntity
     * @uses ArrayOfPersistableEntity::setPersistableEntity()
     * @param \patest\StructType\PersistableEntity[] $persistableEntity
     */
    public function __construct(array $persistableEntity = array())
    {
        $this
            ->setPersistableEntity($persistableEntity);
    }
    /**
     * Get PersistableEntity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\PersistableEntity[]|null
     */
    public function getPersistableEntity()
    {
        return isset($this->PersistableEntity) ? $this->PersistableEntity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPersistableEntity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPersistableEntity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePersistableEntityForArrayConstraintsFromSetPersistableEntity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPersistableEntityPersistableEntityItem) {
            // validation for constraint: itemType
            if (!$arrayOfPersistableEntityPersistableEntityItem instanceof \patest\StructType\PersistableEntity) {
                $invalidValues[] = is_object($arrayOfPersistableEntityPersistableEntityItem) ? get_class($arrayOfPersistableEntityPersistableEntityItem) : sprintf('%s(%s)', gettype($arrayOfPersistableEntityPersistableEntityItem), var_export($arrayOfPersistableEntityPersistableEntityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PersistableEntity property can only contain items of type \patest\StructType\PersistableEntity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PersistableEntity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PersistableEntity[] $persistableEntity
     * @return \patest\ArrayType\ArrayOfPersistableEntity
     */
    public function setPersistableEntity(array $persistableEntity = array())
    {
        // validation for constraint: array
        if ('' !== ($persistableEntityArrayErrorMessage = self::validatePersistableEntityForArrayConstraintsFromSetPersistableEntity($persistableEntity))) {
            throw new \InvalidArgumentException($persistableEntityArrayErrorMessage, __LINE__);
        }
        if (is_null($persistableEntity) || (is_array($persistableEntity) && empty($persistableEntity))) {
            unset($this->PersistableEntity);
        } else {
            $this->PersistableEntity = $persistableEntity;
        }
        return $this;
    }
    /**
     * Add item to PersistableEntity value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PersistableEntity $item
     * @return \patest\ArrayType\ArrayOfPersistableEntity
     */
    public function addToPersistableEntity(\patest\StructType\PersistableEntity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\PersistableEntity) {
            throw new \InvalidArgumentException(sprintf('The PersistableEntity property can only contain items of type \patest\StructType\PersistableEntity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PersistableEntity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\PersistableEntity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\PersistableEntity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\PersistableEntity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\PersistableEntity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\PersistableEntity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PersistableEntity
     */
    public function getAttributeName()
    {
        return 'PersistableEntity';
    }
}
